/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_ENDIAN_H
#define LSG_ENDIAN_H 1

#include <stdio.h>

/**
 * \file  endian.h
 * \brief Endianess conversion functions
 */

typedef enum {
    LSG_ENDIAN_LITTLE,
    LSG_ENDIAN_BIG
} LsgEndian_Endianess;

LsgEndian_Endianess LsgEndian_endianess(void);

void LsgEndian_swap(void* buffer, int size);
void LsgEndian_swapArray(void* buffer, int size, int count);

void LsgEndian_swapShort(short int* buffer);
void LsgEndian_swapInt(int* buffer);
void LsgEndian_swapLong(long int* buffer);

int LsgEndian_readf(FILE* stream, const char* format, ...);

#endif
