/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_HTERRAIN_BVOLUME_H
#define LSG_HTERRAIN_BVOLUME_H

#include <lescegra/coll/bvolume.h>

#include <lescegra/geom/hterrain.h>

typedef struct LsgHTerrainBVolume LsgHTerrainBVolume;
typedef struct LsgHTerrainBVolumeClass LsgHTerrainBVolumeClass;

struct LsgHTerrainBVolume {
    LsgBVolume parent;

    LsgHTerrain* terrain;
};

struct LsgHTerrainBVolumeClass {
    LsgBVolumeClass parent;
};

LsgClassID LsgHTerrainBVolume_classID(void);

#define IS_LSG_HTERRAIN_BVOLUME(instance) \
    LSG_CLASS_INSTANCE_OF((instance), LsgHTerrainBVolume_classID())

#define LSG_HTERRAIN_BVOLUME(instance) \
    LSG_CLASS_INSTANCE_CAST(LsgHTerrainBVolume*, LsgHTerrainBVolume_classID(), (instance))

#define LSG_HTERRAIN_BVOLUME_CLASS(class) \
    LSG_CLASS_CAST(LsgHTerrainBVolumeClass*, LsgHTerrainBVolume_classID(), (class))

LsgHTerrainBVolume* LsgHTerrainBVolume_create(LsgHTerrain* terrain);
void LsgHTerrainBVolume_init(LsgHTerrainBVolume* self, LsgHTerrain* terrain);

#endif
