/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_MESH_BVOLUME_H
#define LSG_MESH_BVOLUME_H 1

#include <lescegra/coll/bvolume.h>

#include <lescegra/geom/mesh.h>

typedef struct LsgMeshBVolume LsgMeshBVolume;
typedef struct LsgMeshBVolumeClass LsgMeshBVolumeClass;

struct LsgMeshBVolume {
    LsgBVolume parent;

    LsgMesh* mesh;
};

struct LsgMeshBVolumeClass {
    LsgMeshClass parent;
};

LsgClassID LsgMeshBVolume_classID(void);

#define IS_LSG_MESH_BVOLUME(instance) \
    LSG_CLASS_INSTANCE_OF((instance), LsgMesgBVolume_classID())

#define LSG_MESH_BVOLUME(instance) \
    LSG_CLASS_INSTANCE_CAST(LsgMeshBVolume*, LsgMeshBVolume_classID(), (instance))

#define LSG_MESH_BVOLUME_CLASS(class) \
    LSG_CLASS_CAST(LsgMeshBVolumeClass*, LsgMeshBVolume_classID(), (class))

LsgMeshBVolume* LsgMeshBVolume_create(LsgMesh* mesh);
void LsgMeshBVolume_init(LsgMeshBVolume* self, LsgMesh* mesh);

#endif
