/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_MESH_H
#define LSG_MESH_H 1

#include <lescegra/sg/node.h>

#include <lescegra/base/types.h>
#include <lescegra/base/vertex.h>
#include <lescegra/coll/octree.h>

typedef struct LsgMesh LsgMesh;
typedef struct LsgMeshClass LsgMeshClass;

struct LsgMesh {
    LsgNode      parent;

    LsgTriangle* triangles;
    LsgTexCoord* texCoords;
    LsgColor*    colors;
    Vertex*      normals;
    Vertex*      vertices;

    int          triangleCount;

    LsgOctree*   octree;
};

struct LsgMeshClass {
    LsgNodeClass parent;
};

LsgClassID LsgMesh_classID(void);

#define IS_LSG_MESH(instance) \
    LSG_CLASS_INSTANCE_OF((instance), LsgMesh_classID())

#define LSG_MESH(instance) \
    LSG_CLASS_INSTANCE_CAST(LsgMesh*, LsgMesh_classID(), (instance))

#define LSG_MESH_CLASS(class) \
    LSG_CLASS_CAST(LsgMeshClass*, LsgMesh_classID(), (class))

void LsgMesh_init(LsgMesh* self);

#endif
