/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_ENVIRONMENT_H
#define LSG_ENVIRONMENT_H 1

#include <lescegra/sg/group.h>

typedef struct LsgEnvironment LsgEnvironment;
typedef struct LsgEnvironmentClass LsgEnvironmentClass;

struct LsgEnvironment {
    LsgGroup parent;

    LsgList* states;
};

struct LsgEnvironmentClass {
    LsgGroupClass parent;
};

LsgClassID LsgEnvironment_classID(void);

#define IS_LSG_ENVIRONMENT(instance) \
    LSG_CLASS_INSTANCE_OF((instance), LsgEnvironment_classID())

#define LSG_ENVIRONMENT(instance) \
    LSG_CLASS_INSTANCE_CAST(LsgEnvironment*, LsgEnvironment_classID(), (instance))

#define LSG_ENVIRONMENT_CLASS(class) \
    LSG_CLASS_CAST(LsgEnvironmentClass*, LsgEnvironment_classID(), (class))

LsgEnvironment* LsgEnvironment_create(void);
void LsgEnvironment_init(LsgEnvironment* self);

#endif
