/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_NAME_H
#define LSG_NAME_H 1

/**
 * \file  name.h
 * \brief Namestack modifier
 */

#include <lescegra/sg/group.h>

typedef struct LsgName LsgName;
typedef struct LsgNameClass LsgNameClass;

/**
 * \brief Namestack modifier
 *
 * Push a name onto the selection name stack while displaying the child
 * nodes.
 */
struct LsgName {
    LsgGroup parent;

    int name;
};

struct LsgNameClass {
    LsgGroupClass parent;
};

LsgClassID LsgName_classID(void);

#define IS_LSG_NAME(instance) \
    LSG_CLASS_INSTANCE_OF((instance), LsgName_classID())

#define LSG_NAME(instance) \
    LSG_CLASS_INSTANCE_CAST(LsgName*, LsgName_classID(), (instance))

#define LSG_NAME_CLASS(class) \
    LSG_CLASS_CAST(LsgNameClass*, LsgName_classID(), (class))

LsgName* LsgName_create(int name);
void LsgName_init(LsgName* self, int name);

#endif
