/*********************************************************************
* lescegra                                                           *
*                                                                    *
* http://geeky.kicks-ass.org/projects/lescegra.html                  *
*                                                                    *
* Copyright 2003-2004 by Enno Cramer <uebergeek@web.de>              *
*                                                                    *
* This library is free software; you can redistribute it and/or      *
* modify it under the terms of the GNU Library General Public        *
* License as published by the Free Software Foundation; either       *
* version 2 of the License, or (at your option) any later version.   *
*                                                                    *
* This library is distributed in the hope that it will be useful,    *
* but WITHOUT ANY WARRANTY; without even the implied warranty of     *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU  *
* Library General Public License for more details.                   *
*                                                                    *
* You should have received a copy of the GNU Library General Public  *
* License along with this library; if not, write to the Free         *
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. *
*********************************************************************/

#ifndef LSG_STATE_H
#define LSG_STATE_H 1

#include <lescegra/base/object.h>

typedef struct LsgState LsgState;
typedef struct LsgStateClass LsgStateClass;

struct LsgState {
    LsgObject parent;
};

struct LsgStateClass {
    LsgObjectClass parent;

    void (*apply)(const LsgState* self);
    void (*restore)(const LsgState* self);
};

LsgClassID LsgState_classID(void);

#define IS_LSG_STATE(instance) \
    LSG_CLASS_INSTANCE_OF((instance), LsgState_classID())

#define LSG_STATE(instance) \
    LSG_CLASS_INSTANCE_CAST(LsgState*, LsgState_classID(), (instance))

#define LSG_STATE_CLASS(class) \
    LSG_CLASS_CAST(LsgStateClass*, LsgState_classID(), (class))

void LsgState_init(LsgState* self);

void LsgState_apply(const LsgState* self);
void LsgState_restore(const LsgState* self);

#endif
