TUT_BIN := $(addprefix $(builddir)/tutorial/, \
           lesson_00 \
           )

TUT_BASE := $(builddir)/tutorial/base.o
TUT_OBJ  := $(TUT_BIN:%=%.o) $(TUT_BASE)

$(TUT_BIN): $(TUT_BASE) $(LIB)

$(TUT_BIN): % : %.o
	$(CC) -o $@ $(TUT_LDFLAGS) $(filter %.o,$^) $(TUT_LIBS)

$(TUT_OBJ): $(builddir)/%.o : $(srcdir)/%.c
	$(CC) -c -o $@ $(TUT_CFLAGS) $(TUT_CPPFLAGS) $<

# automatic dependency tracking
$(builddir)/tutorial/depend: $(TUT_OBJ:$(builddir)/%.o=$(srcdir)/%.c)
	cd $(srcdir) && \
	  $(DEPEND) -f- -p'$$(builddir)/' -- -I$(abs_srcdir)/include -- $(^:$(srcdir)/%=%) 2>/dev/null > $@

include $(builddir)/tutorial/depend

# PHONY targets
.PHONY: build_tut install_tut clean_tut

build_tut: $(TUT_BIN)

install_tut: build_tut
	mkdir -p $(docdir)/tutorial
	cp $(TUT_BIN) $(docdir)/tutorial

clean_tut:
	rm -f $(builddir)/tutorial/depend
	rm -f $(TUT_BIN)
	rm -f $(TUT_OBJ)
